#ifndef VDM_header_t
#define VDM_header_t


/* ------- PHASE1 ------------------ */
#if defined(sun) && ! defined(sparc)
#define __BSD42__
#endif

#ifdef M_XENIX
#define __XENIX__
#define __SYSV__
#endif

#ifdef __TURBOC__
#define __DOS__
#endif

#if defined(__TURBOC__) || defined(__ANSIC__) || defined(__STDC__)
typedef void * VOIDptr;
#else
typedef char * VOIDptr;
#endif

#if defined(__linux__) || defined(_AIX) || defined(MIPSEL) || (defined(sun) && defined(sparc))
#ifndef __POSIX
#define __POSIX
#endif
#endif

#ifdef __cplusplus
#include <stdlib.h>
#else
#ifdef __STDC__
#ifndef apollo
#include <stdlib.h>
#endif
#endif
#endif

#ifdef __cplusplus
#include <stdio.h>
#endif

#ifdef __cplusplus
#include <iostream.h>
#else
#include <stdio.h>
#endif

#include <stdio.h>

#ifdef __BSD42__
#include <strings.h>
#else
#include <string.h>
#endif

/* some systems define TRUE and FALSE in system header files */
#ifndef FALSE
#ifndef TRUE

/* Bool as enum requires conversion between enum and int */
#ifdef BoolAsEnum
enum {FALSE,TRUE};
#else
#define FALSE ((unsigned char)0)
#define TRUE ((unsigned char)1)
#endif

#ifdef __cplusplus
#define false BOOL(FALSE)
#define true BOOL(TRUE)
#endif

#endif
#endif

typedef unsigned char Bool;

#define lb_nat0 0

#define ub_nat0 2147483647

typedef unsigned long Nat0;

#define lb_nat1 1

#define ub_nat1 2147483647

typedef unsigned long Nat1;

#define lb_intg -2147483647

#define ub_intg 2147483647

typedef long int Intg;

typedef char Char;
#define lb_char 0

#define ub_char 255

typedef struct Struct_cvtext_vdmlib * Cvtext_vdmlib;
typedef struct Struct_n1seq * N1seq;
typedef struct Struct_imap * Imap;
typedef struct Struct_nset * Nset;
typedef struct Struct_str * Str;

/* ------- PHASE2 ------------------ */
#define VDM_ERR_EMPTYSET 1
#define VDM_ERR_EMPTYMAP 2
#define VDM_ERR_EMPTYHD 3
#define VDM_ERR_ERRMAXLEN 4
#define VDM_ERR_NILPTR 5
#define VDM_ERR_NILOPT 6
#define VDM_ERR_ILLPTR 7
#define VDM_ERR_SELECT 8
#define VDM_ERR_SELMAP 9
#define VDM_ERR_UNIO 10
#define VDM_ERR_EMPTYTL 11
#define VDM_ERR_UNION 12
#define VDM_ERR_NOTIMPL 13
#define VDM_ERR_HEAPOFL 15
#define VDM_ERR_CVLINES 16
#define VDM_ERR_NV_HDL 17
#define VDM_ERR_EMPTYIT 18
#define VDM_ERR_DIV0 19

extern Bool supress_cvlines_vdmlib;
extern Nat0 curr_linelen_vdmlib;
extern char *start_structure_vdmlib;
extern char *end_structure_vdmlib;

extern void adj_linelen_vdmlib ( Nat0 x1 ) ;
extern Str ident_prefix_vdmlib ( Str x1, Nat0 x2 ) ;
extern Cvtext_vdmlib ident_lines_vdmlib ( Cvtext_vdmlib x1, Str x2 ) ;
extern Cvtext_vdmlib close_struct_vdmlib ( Cvtext_vdmlib x1,Str x2, Nat0 x3 ) ;
extern Cvtext_vdmlib append_lastline_vdmlib ( Cvtext_vdmlib x1,Cvtext_vdmlib x2 ) ;
extern Cvtext_vdmlib cvlines2_cvtext_vdmlib ( Cvtext_vdmlib x1,Cvtext_vdmlib x2 ) ;
#ifdef __cplusplus
extern void fprint_lines_vdmlib ( ostream & x1,Cvtext_vdmlib x2 ) ;
#else
extern void fprint_lines_vdmlib ( FILE *x1,Cvtext_vdmlib x2 ) ;
#endif

#ifdef __cplusplus
inline VOIDptr ALLOCMEM_vdmlib(unsigned long int x1)
{ return (VOIDptr)(new char[x1]); }
inline void FREEMEM_vdmlib(VOIDptr x1,unsigned long int)
{ delete (char *)(x1); }
#else
#if ! defined(__STDC__) && ! defined(_AIX) && ! defined(__NOMALLOC__)
extern VOIDptr malloc ( unsigned long x1 ) ;
extern void free ( VOIDptr x1 ) ;
#endif
#define ALLOCMEM_vdmlib(x1) malloc(x1)
#define FREEMEM_vdmlib(x1,x2) free(x1)
#endif

struct Struct_cvtext_vdmlib {
Nat0 f_max;
Nat0 f_len;
};

struct Struct_n1seq {
N1seq f_next;
Nat1 f_info;

};

struct Struct_imap {
Imap f_next;
Nat0 f_info;
Str f_attr;
};

struct Struct_nset {
Nset f_next;
Nat0 f_info;

};

struct Struct_rec {
Nat0 f_dummy;
};

typedef struct Struct_rec Rec;

#define cvlines2_rec(x1,x2) cvlines2_vdmlib(x1,x2)
struct Struct_str {
Nat0 f_max;
Nat0 f_len;
};
#define cvlines2_str(x1,x2) cvlines2_vdmlib(x1,x2)

#define mk1_str_char(x1) mk1_str(x1)

enum Enum_uni {

d_rec_uni
,
d_nat0_uni

}; typedef enum Enum_uni discriminant_uni;

struct Struct_uni {
discriminant_uni tag_uni;

union {

Rec f_rec_uni ;

Nat0 f_nat0_uni ;

} var_uni;

};

typedef struct Struct_uni Uni;

/* ------- PHASE3 ------------------ */
extern void abort_vdmlib ( Nat0 x1 );
extern void heap_oflw_vdmlib ( char *x1 );
extern void err_uuni_vdmlib ( char *x1 );
extern void err_sel_vdmlib ( Nat1 x1 , Nat0 x2 , char *x3 );
extern void err_tag_vdmlib ( char *x1 );
extern char * printformat_nat0;

extern void set_print_format_nat0 ( char * x1 );
extern Str cvstr_nat0 ( Nat0 x1 );
extern Cvtext_vdmlib cvlines_nat0 ( Nat0 x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Bool is_eq_char ( Char x1 , Char x2 );
extern Cvtext_vdmlib alloc_cvtext_vdmlib ( Nat0 x1 );
extern void free_cvtext_vdmlib ( Cvtext_vdmlib x1 );

#define ref_cvtext_vdmlib(x1) (x1)

#define profile_cvtext_vdmlib()

extern Str alloc_str ( Nat0 x1 );
extern void free_str ( Str x1 );

#define ref_str(x1) (x1)

#define profile_str()

extern N1seq alloc_n1seq ( void );
extern void free_n1seq ( N1seq x1 );

#define ref_n1seq(x1) (x1)

#define profile_n1seq()

extern Imap alloc_imap ( void );
extern void free_imap ( Imap x1 );

#define ref_imap(x1) (x1)

#define profile_imap()

extern Nset alloc_nset ( void );
extern void free_nset ( Nset x1 );

#define ref_nset(x1) (x1)

#define profile_nset()

typedef void (* T2_forall_cvtext_vdmlib) ( Str y1 ) ;
extern void forall_cvtext_vdmlib ( Cvtext_vdmlib x1, T2_forall_cvtext_vdmlib x2 ) ;
extern Bool is_empty_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern void del_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern Str hd_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern Cvtext_vdmlib ovwrt1_cvtext_vdmlib ( Cvtext_vdmlib x1 , Nat1 x2 , Str x3 );
extern Str sel_cvtext_vdmlib ( Cvtext_vdmlib x1 , Nat1 x2 );
extern Nat0 len_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern void del1_cvtext_vdmlib ( Cvtext_vdmlib x1 );
extern Cvtext_vdmlib mk1_cvtext_vdmlib ( Str x1 );
extern Cvtext_vdmlib appr_cvtext_vdmlib ( Cvtext_vdmlib x1 , Str x2 );
extern Cvtext_vdmlib conc_cvtext_vdmlib ( Cvtext_vdmlib x1 , Cvtext_vdmlib x2 );
extern Cvtext_vdmlib mk_empty_cvtext_vdmlib ( void );
extern Str last_cvtext_vdmlib ( Cvtext_vdmlib x1 );

extern Cvtext_vdmlib cvlines1_rec ( Rec x1 );

extern Rec copy1_rec ( Rec x1 );
#ifdef __cplusplus
extern void fpr_rec ( ostream & x1 , Rec x2 );
#else
extern void fpr_rec ( FILE *x1 , Rec x2 );
#endif
extern Str format_rec ( Rec x1 );
extern Rec mk_rec

( void )

;
extern void del1_rec ( Rec x1 );
extern Cvtext_vdmlib cvlines_rec ( Rec x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
typedef void (* T2_forall_str) ( Char y1 ) ;
extern void forall_str ( Str x1, T2_forall_str x2 ) ;

extern Str cvstr_str ( Str x1 );

extern Str mkn_str ( Char x1 , Nat0 x2 );
extern Nat0 index_str ( Str x1 , Char x2 );
extern Char hd_str ( Str x1 );
extern void del1_str ( Str x1 );
extern void cpc_str ( Str x1 , Char *x2 );
extern Str appr_str ( Str x1 , Char x2 );
extern Str mk_empty_str ( void );
#ifdef __cplusplus
extern void fpr_str ( ostream & x1 , Str x2 );
#else
extern void fpr_str ( FILE *x1 , Str x2 );
#endif
extern Char sel_str ( Str x1 , Nat1 x2 );
extern Str conc_str ( Str x1 , Str x2 );
extern Str mkc_str ( Char *x1 );
extern Cvtext_vdmlib cvlines_str ( Str x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
extern Str mk1_str ( Char x1 );
extern Str copy_str ( Str x1 );
extern Str ovwrt1_str ( Str x1 , Nat1 x2 , Char x3 );
extern void del_str ( Str x1 );
extern Nat0 len_str ( Str x1 );
typedef void (* T2_forindex_str) ( Char y1, Nat1 y2 ) ;
extern void forindex_str ( Str x1, T2_forindex_str x2 ) ;

extern Uni mk_rec_uni ( Rec x1 );

extern Uni mk_nat0_uni ( Nat0 x1 );

extern Uni copy1_uni ( Uni x1 );

extern Rec rec_uni ( Uni x1 );

extern Nat0 nat0_uni ( Uni x1 );

extern Cvtext_vdmlib cvlines_uni ( Uni x1 );
/* global variable 'curr_linelen_vdmlib' determines line length */
#ifdef __cplusplus
extern void fpr_uni ( ostream & x1 , Uni x2 );
#else
extern void fpr_uni ( FILE *x1 , Uni x2 );
#endif
extern Str format_uni ( Uni x1 );

extern Bool is_rec_uni ( Uni x1 );

extern Bool is_nat0_uni ( Uni x1 );

extern void del1_uni ( Uni x1 );
extern discriminant_uni discr_uni ( Uni x1 );

/* ------- PHASE4 ------------------ */

#endif
