#!/bin/sh
# $Id: beep.tcl,v 1.1 1996/08/26 18:41:49 uwe Exp $
# the next line restarts using wish (must be wish4.0 or newer) \
exec wish "$0" "$@"

wm iconify .

# message output routine: message
source message.tcl

# socket i/o: openSocket, readSocket, ....
source clientsocket.tcl

# options evaluation: evalOptions
source circleoptions.tcl

# routines for detecting overlapping circles

set state(circles) {}

proc moveCircle {who x y} {
    global state

    message 3 "detectOverlap: $who at $x $y"

    if { ! [info exists state($who,x)] } {
	message 2 "new circle $who"

	lappend state(circles) $who
	foreach c $state(circles) {
	    set state($c,$who,overlap) 0
	    set state($who,$c,overlap) 0
	}
	set state($who,$who,overlap) 1
    }

    set state($who,x) $x
    set state($who,y) $y


    set beep 0
    foreach circle $state(circles) {
	set oldoverlap $state($circle,$who,overlap)

	set delta2 [distanceCircles $circle $who]
	set newoverlap [expr $delta2 <= 4 * $state(radius) * $state(radius)]

	# new overlapping circles
	if {$oldoverlap < $newoverlap} {
	    message 2 "new overlap: $who and $circle"
	    set beep 1
	}

	set state($circle,$who,overlap) $newoverlap
	set state($who,$circle,overlap) $newoverlap
    }

    if $beep {
	writeSocket "bell"
    }

    return
}

proc distanceCircles {c1 c2} {
    global state
    set dx [expr $state($c1,x) - $state($c2,x)]
    set dy [expr $state($c1,y) - $state($c2,y)]

    return [expr $dx * $dx + $dy * $dy]
}


proc createCircle {who color} { }

proc configCircle {who args} { }

proc deleteCircle {who} {
    global state

    if [info exists state($who,x)] {

	message 2 "delete circle $who"

	unset state($who,x) state($who,y)

	foreach c $state(circles) {
	    unset state($who,$c,overlap)
	    catch {unset state($c,$who,overlap)}
	}

	set i [lsearch $state(circles) $who]
	set state(circles) [lreplace $state(circles) $i $i]

    }
}


proc init {} {
    openSocket
    bind . <Destroy>	"finish"
    bind . <Control-q>	"finish"
}


proc terminate {} {
    message 2 "terminate beep application: close socket"
    closeSocket
}

proc finish {} {
    global state

    terminate
    message 2 "exit"
    exit
}

init
