#!/bin/sh
# $Id: mouse-stand-alone.tcl,v 1.1 1996/12/02 14:58:45 uwe Exp $
# the next line restarts using wish (must be wish4.0 or newer) \
exec wish "$0" "$@"

proc initCanvas {} {
    global state

    canvas .c
    .c configure -height 200 -width 200
    pack .c
}

proc moveCircle {x y} {
    global state

    set dx [expr $x - $state(x)]
    set dy [expr $y - $state(y)]
    .c move redball $dx $dy
    
    set state(x) $x
    set state(y) $y

    return
}

proc createCircle {} {
    global state

    set x 100
    set y 100
    
    set state(x) $x
    set state(y) $y

    set x0 [expr $x - 10]
    set y0 [expr $y - 10]
    set x1 [expr $x + 10]
    set y1 [expr $y + 10]

    .c create oval $x0 $y0 $x1 $y1 -fill red -width 0 -outline red -tags redball
}

proc configCircle args {
    eval .c itemconfigure redball $args
}

# specific bindings for this application --------------------

proc moveCircleOn {x y} {
    global state

    moveCircle		$x $y
    configCircle	-width 3 -outline black

    bind .c <Motion>	"moveCircle %x %y"
    bind .c <Leave>	"bell"
    bind .c <1>		"moveCircleOff"
}

proc moveCircleOff {} {
    global state

    configCircle	-width 0 -outline red
    bind .c <Motion>	""
    bind .c <Leave>	""
    bind .c <1>		"moveCircleOn %x %y"
}

# initialization and finalisation --------------------

proc init {} {
    global state

    initCanvas

    createCircle

    moveCircleOff
    bind . <Control-q>	"exit"
    bind . <Destroy>	"exit"
}

init

