#!/bin/sh
# $Id: walk-stand-alone.tcl,v 1.1 1996/12/02 15:40:17 uwe Exp $
# the next line restarts using wish (must be wish4.0 or newer) \
exec wish "$0" "$@"

# random generator: random [seed], choose min max
source random.tcl

proc initCanvas {} {
    canvas .c
    .c configure -height 200 -width 200
    pack .c
}

proc moveCircle {x y} {
    global state

    set dx [expr $x - $state(x)]
    set dy [expr $y - $state(y)]
    .c move blueball $dx $dy
    
    set state(x) $x
    set state(y) $y

    return
}

proc createCircle {} {
    global state

    set x 100
    set y 100

    set state(x) 100
    set state(y) 100

    set x0 90
    set y0 90
    set x1 110
    set y1 110

    .c create oval $x0 $y0 $x1 $y1 -fill blue -width 0 -outline blue -tags blueball
}

# specific bindings for this application --------------------

proc walk {} {
    global state

    if $state(walk) {
	set x $state(x)
	set y $state(y)

	incr x [choose -20 21]
	incr y [choose -20 21]

	if {$x <  -10}	{incr x  210}
	if {$x >= 210}	{incr x -210}
	if {$y <  -10}	{incr y  210}
	if {$y >= 210}	{incr y -210}

	moveCircle $x $y

	after 50 walk
    }
}

proc randomWalkOn {} {
    global state

    set state(walk) 1
    bind .c <1>		"randomWalkOff"

    after 0 walk
}

proc randomWalkOff {} {
    global state

    set state(walk)	0
    bind .c <1>		"randomWalkOn"
}

# initialization and finalisation --------------------

proc init {} {
    global state

    initCanvas

    createCircle

    randomWalkOff

    bind . <Control-q>	"exit"
    bind . <Destroy>	"exit"
}

init

